/* Sistemas Integrados TEKNISA
  Integrao

Nome: 0010_MAKSTPO_EXPORTA_INF_PROD.SQL

@C:\web_550\sql\end_conv\oracle\clientes\mak\0010_MAKSTPO_EXPORTA_INF_PROD.SQL

Descrio:
Rotina para exportao de produtos, ???? para o sistema Teknisa.

Criao:
29/06/2012 - Fabrcio Marcelo da Silva
*/


CREATE OR REPLACE
PROCEDURE USR_EXPORTA_INF_PROD
IS
   ARQUIVO         UTL_FILE.FILE_TYPE;
   V_CAMINHO       VARCHAR2(100);

   V_CRIARQUIVO    BOOLEAN := TRUE;
BEGIN
   /* Diretrio onde sero gerados os arquivos com extenso txt para
      serem importados pelo PDV (Makro) */
   BEGIN
      SELECT DSDIRETORIO
        INTO V_CAMINHO
        FROM DIRETORIOS
       WHERE CDPROGRAMA = 'MAK00100';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CAMINHO := NULL;
   END;

   IF NOT V_CAMINHO IS NULL THEN

      /* Exportao do cadastro de Produtos por filial */
      FOR C_PLU_STORE IN (SELECT '0'  || '|' ||                                                               /* Status */
                                 '11' || '|' ||                                                               /* Record */
                                 PF.CDEXFILIAL|| '|' ||                                                       /* store_key */
                                 SUBSTR(P.CDARVPROD,1,10) || '|' ||                                           /* id */
                                 '0' || '|' ||                                                                /* desired_margin_perc */
                                 '0' || '|' ||                                                                /* quantity_in_stock */
                                 ' ' || '|' ||                                                                /* out_of_stock_day */
                                 ' ' || '|' ||                                                                /* last_entered_day */
                                 ' ' || '|' ||                                                                /* last_sale_day */
                                 LTRIM(REPLACE(TO_CHAR(NVL(I.VRPRECITEM,0),'999999999.999'),'.',''))|| '|' || /* cost */
                                 ' ' || '|' ||                                                                /* start_cost */
                                 ' ' || '|' ||
                                 ' ' || '|' ||
                                 '0' || '|' ||
                                 DECODE(PR.IDPRODATIV, 'A', '0', '1') || '|' ||                               /* not_for_sale */
                                 '0' || '|' ||
                                 '0' || '|' ||
                                 '0' || '|' ||
                                 '0' || '|' ||
                                 '12' || '|' ||
                                 '0' || '|' ||
                                 LPAD(LTRIM(REPLACE(TO_CHAR(NVL(A.VRPEALIMPFIS,0),'99.99'),'.','')),4,'0') || '|' ||
                                 '0' || '|' ||
                                 LPAD(LTRIM(REPLACE(TO_CHAR(NVL(A.VRPEALIMPFIS,0),'99.99'),'.','')),4,'0') || '|' ||
                                 '0' || '|' ||
                                 '0' AS PRODFILI
                            FROM PRODUTO P, PARAVEND PV, TABEVEND T,
                                 ITEMPRECO I, PARAMFILIAL PF, PRODFILI PR, ALIQIMPFIS A
                           WHERE ((P.USR_DTEXPPROD IS NULL) OR (P.DTULTATUPROD >= P.USR_DTEXPPROD))
                             AND P.CDNVPRODUTO = '5'
                             AND P.CDARVPROD LIKE '7%'
                             AND T.CDFILIAL = PV.CDFILIAL
                             AND T.CDTABEPREC = PV.CDTABEPREC
                             AND SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC
                             AND I.CDFILIAL    = T.CDFILIAL
                             AND I.CDTABEPREC  = T.CDTABEPREC
                             AND I.DTINIVGPREC = T.DTINIVGPREC
                             AND I.CDPRODUTO   = P.CDPRODUTO
                             AND PF.CDFILIAL = PV.CDFILIAL
                             AND NOT PF.CDEXFILIAL IS NULL
                             AND PR.CDFILIAL = I.CDFILIAL
                             AND PR.CDPRODUTO = P.CDPRODUTO
                             AND A.CDFILIAL (+)  = PR.CDFILIAL
                             AND A.CDPRODUTO (+) = PR.CDPRODUTO
                             AND A.CDIMPOSTO (+) = '00')
      LOOP

         IF V_CRIARQUIVO THEN
            ARQUIVO := UTL_FILE.FOPEN(V_CAMINHO, 'EXP_PROD_FILI' || TO_CHAR(SYSDATE, 'DDMMYYYY_HHMISS') || '.TXT', 'A');
            V_CRIARQUIVO := FALSE;
         END IF;
         UTL_FILE.PUT_LINE(ARQUIVO, C_PLU_STORE.PRODFILI);

      END LOOP;
      UTL_FILE.FCLOSE(ARQUIVO);

      V_CRIARQUIVO := TRUE;

     /* Exportao do cadastro de Produtos por filial (Codigo de barras) */
      FOR C_PLU_SKU_STORE IN (SELECT '0'  || '|' ||                                /* Status */
                                     '13' || '|' ||                                /* Record */
                                     SUBSTR(PB.CDBARRAPROD,1,14)|| '|' ||          /* sku_id */
                                     PF.CDEXFILIAL || '|' ||                       /* store_key */
                                     SUBSTR(P.CDARVPROD,1,10) AS CODBARRAS         /* plu_id */
                                FROM PRODUTO P, PARAMFILIAL PF, CDBARRAPROD PB
                               WHERE ((P.USR_DTEXPPROD IS NULL) OR (P.DTULTATUPROD >= P.USR_DTEXPPROD))
                                 AND P.CDNVPRODUTO = '5'
                                 AND P.CDARVPROD LIKE '7%'
                                 AND PB.CDPRODUTO = P.CDPRODUTO
                                 AND NOT PB.CDBARRAPROD IS NULL
                                 AND NOT PF.CDEXFILIAL IS NULL
                              UNION ALL
                              SELECT '0'  || '|' ||                                 /* Status */
                                     '13' || '|' ||                                 /* Record */
                                     SUBSTR(P.CDBARPRODUTO,1,14) || '|' ||          /* sku_id */
                                     PF.CDEXFILIAL || '|' ||                        /* store_key */
                                     SUBSTR(P.CDARVPROD,1,10) AS CODBARRAS          /* plu_id */
                                FROM PRODUTO P, PARAMFILIAL PF
                               WHERE ((P.USR_DTEXPPROD IS NULL) OR (P.DTULTATUPROD >= P.USR_DTEXPPROD))
                                 AND P.CDNVPRODUTO = '5'
                                 AND P.CDARVPROD LIKE '7%'
                                 AND NOT P.CDBARPRODUTO IS NULL
                                 AND NOT PF.CDEXFILIAL IS NULL)
      LOOP

         IF V_CRIARQUIVO THEN
            ARQUIVO := UTL_FILE.FOPEN(V_CAMINHO, 'EXP_PROD_BARRAS' || TO_CHAR(SYSDATE, 'DDMMYYYY_HHMISS') || '.TXT', 'A');
            V_CRIARQUIVO := FALSE;
         END IF;
         UTL_FILE.PUT_LINE(ARQUIVO, C_PLU_SKU_STORE.CODBARRAS);

      END LOOP;
      UTL_FILE.FCLOSE(ARQUIVO);

      V_CRIARQUIVO := TRUE;

      /* Exportao de preo de venda dos produtos (por filial) */
      FOR C_PRICING IN (SELECT '0'  || '|' ||                                                                  /* Status */
                               '12' || '|' ||                                                                  /* Record */
                               PF.CDEXFILIAL || '|' ||                                                         /* store_key */
                               SUBSTR(P.CDARVPROD,1,10) || '|' ||                                              /* id */
                               LTRIM(REPLACE(TO_CHAR(NVL(I.VRPRECITEM,0),'999999999.999'),'.','')) || '|' ||   /* Price */
                               TO_CHAR(T.DTINIVGPREC, 'DDMMYYYY')|| '|' ||                                     /* Start_price */
                               '000001' || '|' ||                                                              /* time_price */
                               '1' || '|' ||                                                                   /* type_price */
                               '0' || '|' ||                                                                   /* promotion */
                               '0' || '|' ||                                                                   /* code_promotion */
                               '0' || '|' ||                                                                   /* points */
                               '0' || '|' ||                                                                   /* quantity */
                               '0' || '|' ||                                                                   /* rate */
                               '0' AS PRECPROD                                                                 /* Sequence */
                          FROM PRODUTO P, PARAMFILIAL PF, PARAVEND PV, TABEVEND T,
                               ITEMPRECO I
                         WHERE ((P.USR_DTEXPPROD IS NULL) OR (P.DTULTATUPROD >= P.USR_DTEXPPROD))
                           AND P.CDNVPRODUTO = '5'
                           AND P.CDARVPROD LIKE '7%'
                           AND T.CDFILIAL = PV.CDFILIAL
                           AND T.CDTABEPREC = PV.CDTABEPREC
                           AND SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC
                           AND I.CDFILIAL    = T.CDFILIAL
                           AND I.CDTABEPREC  = T.CDTABEPREC
                           AND I.DTINIVGPREC = T.DTINIVGPREC
                           AND I.CDPRODUTO   = P.CDPRODUTO
                           AND PF.CDFILIAL = PV.CDFILIAL
                           AND NOT PF.CDEXFILIAL IS NULL)
      LOOP

         IF V_CRIARQUIVO THEN
            ARQUIVO := UTL_FILE.FOPEN(V_CAMINHO, 'EXP_PREC_PROD' || TO_CHAR(SYSDATE, 'DDMMYYYY_HHMISS') || '.TXT', 'A');
            V_CRIARQUIVO := FALSE;
         END IF;
         UTL_FILE.PUT_LINE(ARQUIVO, C_PRICING.PRECPROD);

      END LOOP;
      UTL_FILE.FCLOSE(ARQUIVO);

      V_CRIARQUIVO := TRUE;

      /* Exportao do cadastro de Produtos */
      FOR C_PLU IN (SELECT '0'  || '|' ||                                      /* Status */
                           '10' || '|' ||                                      /* Record */
                           SUBSTR(P.CDARVPROD,1,10) || '|' ||                  /* id */
                           (SELECT CDPRODINTE
                              FROM PRODUTO
                             WHERE CDARVPROD = SUBSTR(P.CDARVPROD,1,3)) || '|' || /* base_plu_key */
                           ' ' || '|' ||                                       /* link_plu_key */
                           '3' || '|' ||                                       /* plu_types */
                           ' ' || '|' ||                                       /* maker_key */
                           SUBSTR(P.NMPRODUTO,1,22) || '|' ||                  /* short_description */
                           SUBSTR(P.NMPRODUTO,1,22) || '|' ||                  /* long_description */
                           SUBSTR(P.NMPRODUTO,1,22) || '|' ||                  /* commercial_description */
                           ' ' || '|' ||                                       /* image_file */
                           ' ' || '|' ||                                       /* pos_id */
                           '3' || '|' ||                                       /* cost_decimals */
                           SUBSTR(P.SGUNIDADE,1,4) || '|' ||                   /* unit_key */
                           '3' || '|' ||                                       /* price_decimals */
                           '0' || '|' ||                                       /* adder */
                           ' ' || '|' ||                                       /* department_key */
                           ' ' || '|' ||                                       /* suggested_prompt */
                           ' ' || '|' ||                                       /* data_entry_key */
                           ' ' || '|' ||                                       /* tare_key */
                           'F' || '|' ||                                       /* is_completion */
                           '0' || '|' ||                                       /* has_deposit */
                           '0' || '|' ||                                       /* has_plu_link */
                           '0' || '|' ||                                       /* price_required */   
                           '0' || '|' ||                                       /* quantity_disallowed */
                           '0' || '|' ||                                       /* quantity_required */
                           DECODE(P.IDPESAPROD, 'S', 'F', 'T') || '|' ||       /* decimal_disallowed */
                           DECODE(P.IDPESAPROD, 'S', 'T', 'F') || '|' ||       /* decimal_required */
                           '0' || '|' ||                                       /* id_required */
                           '0' || '|' ||                                       /* repeat_disallowed */
                           '0' || '|' ||                                       /* scale */
                           '0' || '|' ||                                       /* tracking_total */
                           '0' || '|' ||                                       /* deposit */
                           '0' || '|' ||                                       /* non_merchandise */
                           '0' || '|' ||                                       /* return_disallowed */
                           '0' || '|' ||                                       /* refund_disallowed */
                           '0' || '|' ||                                       /* markdown_disallowed */
                           '0' || '|' ||                                       /* rebate */
                           '0' || '|' ||                                       /* not_for_sale */
                           '0' || '|' ||                                       /* negative */
                           '0' || '|' ||                                       /* clerk_required */
                           '0' || '|' ||                                       /* kit */
                           DECODE(P.IDPESAPROD, 'S', 'T', 'F') || '|' ||       /* for_scale */
                           '0' || '|' ||                                       /* delivery */
                           '0' || '|' ||                                       /* authrizer_required */
                           ' ' || '|' ||                                       /* qty_from_amount */
                           ' ' || '|' ||                                       /* print_etq */
                           ' ' || '|' ||                                       /* completion */
                           '0' || '|' ||                                       /* is_plu_base */
                           '0' || '|' ||                                       /* store_adm_price */
                           '0' || '|' ||                                       /* reverse_kit */
                           '0' || '|' ||                                       /* verify_stock */
                           ' ' || '|' ||                                       /* valid_days */
                           NVL(CDCLASFISC, ' ') || '|' ||                      /* NCM/SH */
                           '0' || '|' ||                                       /* pis_cofins */
                           ' ' || '|' ||                                       /* quantity */
                           ' ' || '|' ||                                       /* Quantity_min */
                           ' ' || '|' ||                                       /* Quantity_max */
                           ' ' || '|' ||                                       /* Class */
                           '0' || '|' ||                                       /* merchandise_origin */
                           ' ' || '|' ||                                       /* merchandise_group */
                           ' ' || '|' ||                                       /* Package */
                           ' ' || '|' ||                                       /* wholesale_quantity */
                           ' ' || '|' ||                                       /* delivery_type */
                           ' ' || '|' ||                               /* message_subtotal */
                           SUBSTR(P.SGUNIDADE,1,4) || '|' ||                   /* standard_unit */
                           ' ' || '|' ||                                       /* quantity_standard */
                           ' ' || '|' ||                                       /* is_produced */
                           ' ' AS PRODUTO,                                     /* is_input */
                           CDPRODUTO
                      FROM PRODUTO P
                     WHERE ((P.USR_DTEXPPROD IS NULL) OR (P.DTULTATUPROD >= P.USR_DTEXPPROD))
                       AND P.CDNVPRODUTO = '5'
                       AND P.CDARVPROD LIKE '7%')
      LOOP

         IF V_CRIARQUIVO THEN
            ARQUIVO := UTL_FILE.FOPEN(V_CAMINHO, 'EXP_PROD_' || TO_CHAR(SYSDATE, 'DDMMYYYY_HHMISS') || '.TXT', 'A');
            V_CRIARQUIVO := FALSE;
         END IF;
         UTL_FILE.PUT_LINE(ARQUIVO, C_PLU.PRODUTO);

         /* Atualizao do produto para no ser exportado at que haja alguma alterao do mesmo */
         UPDATE PRODUTO
            SET USR_DTEXPPROD = SYSDATE
          WHERE CDPRODUTO = C_PLU.CDPRODUTO;

      END LOOP;
      UTL_FILE.FCLOSE(ARQUIVO);
      COMMIT;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPORTA_INF_PROD','5.50.XXX'); END;
/
